part of xwidgetbase;

class XfxElencoItem extends StatefulWidget {
  XfxElencoItem({
    Key? key,
    this.childMain,
    this.childDetails,
    this.showingDetails = false,
    this.showMainWithDetails = true,
    this.decorationBackGroundContainer,
    this.changeStatoWithTap = true,
    this.onTapItem,
    this.onLongTapItem,
    this.onDoubleTapItem,
    this.margin,
    this.crossAxisAlignment,
  }) : super(key: key);

  /// default TRUE
  bool showMainWithDetails;
  Widget? childMain;
  bool showingDetails;
  Widget? childDetails;
  bool? changeStatoWithTap;
  Decoration? decorationBackGroundContainer;
  EdgeInsetsGeometry? margin;
  CrossAxisAlignment? crossAxisAlignment;
  Function()? onTapItem;
  Function()? onLongTapItem;
  Function()? onDoubleTapItem;
  @override
  _XfxElencoItemState createState() => _XfxElencoItemState();
}

class _XfxElencoItemState extends State<XfxElencoItem> {
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: widget.onTapItem ??
            () {
              if (widget.changeStatoWithTap == true) {
                setState(() {
                  widget.showingDetails = !widget.showingDetails;
                });
              }
            },
        onLongPress: widget.onLongTapItem ?? () {},
        onDoubleTap: widget.onDoubleTapItem ?? () {},
        child: Container(
            decoration: widget.decorationBackGroundContainer ?? BoxDecoration(color: Colors.grey[900]),
            margin: widget.margin ?? EdgeInsets.only(bottom: 2),
            child: Column(crossAxisAlignment: widget.crossAxisAlignment ?? CrossAxisAlignment.center, children: [
              (widget.showMainWithDetails == false && widget.showingDetails == true) ? Container() : widget.childMain ?? Container(),
              (widget.showingDetails == true) ? widget.childDetails! : Container(),
            ])));
  }
}
